#!/usr/bin/python
import sys
import os
import pyuppaal
import unittest
from successor import *

class TestBasicSuccessor(unittest.TestCase):
    def test_sync_single(self):
        model_file = open(os.path.join(os.path.dirname(sys.argv[0]), 'synchronisation_simple.xml'), "r")
        model = pyuppaal.from_xml(model_file)
        succ_gen = SuccessorGenerator(model, "")
        succ_gen.clocks = []
        succ_gen.variables = []

        state = succ_gen.get_initialstate()
        succs = list(succ_gen.successors(state))
        self.assertEqual(len(succs), 1)

    def test_sync_multiple(self):
        model_file = open(os.path.join(os.path.dirname(sys.argv[0]), 'synchronisation_simple2.xml'), "r")
        model = pyuppaal.from_xml(model_file)
        succ_gen = SuccessorGenerator(model, "")
        succ_gen.clocks = []
        succ_gen.variables = []

        state = succ_gen.get_initialstate()
        succs = list(succ_gen.successors(state))
        self.assertEqual(len(succs), 2)
        


if __name__ == '__main__':
    unittest.main()
